VERSION 5.00
Begin VB.Form frmIcon 
   BorderStyle     =   0  'None
   ClientHeight    =   225
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2010
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   Icon            =   "frmSysTray.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   225
   ScaleWidth      =   2010
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   WindowState     =   1  'Minimized
   Begin VB.Menu mnuPopup 
      Caption         =   "Popup Menu"
      Begin VB.Menu mnu 
         Caption         =   "&Info/Prefs..."
         Index           =   1
      End
      Begin VB.Menu mnu 
         Caption         =   "&Play"
         Index           =   2
      End
      Begin VB.Menu mnu 
         Caption         =   "&Stop"
         Index           =   3
      End
      Begin VB.Menu mnu 
         Caption         =   "P&ause"
         Index           =   4
      End
      Begin VB.Menu mnu 
         Caption         =   "&Next"
         Index           =   5
      End
      Begin VB.Menu mnu 
         Caption         =   "Pre&vious"
         Index           =   6
      End
      Begin VB.Menu mnu 
         Caption         =   "Add &File"
         Index           =   7
      End
      Begin VB.Menu mnu 
         Caption         =   "Select S&kin"
         Index           =   8
      End
      Begin VB.Menu mnu 
         Caption         =   "&Visual Playlist Selector"
         Index           =   9
      End
      Begin VB.Menu mnu 
         Caption         =   "&Load Playlist"
         Index           =   10
      End
      Begin VB.Menu mnu 
         Caption         =   "Clear Playlist"
         Index           =   11
      End
      Begin VB.Menu mnu 
         Caption         =   "&Close"
         Index           =   12
      End
   End
End
Attribute VB_Name = "frmIcon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Tray Icon
'=========
' Initializes the system tray icon and menu and responds
' to mouse and menu events. Calls code in main VB-Amp form.
'
' Thanks to: Ben Baird <psyborg@cyberhighway.com> for
' most of the system tray code.

Option Explicit

Private Sub Form_Load()

'Add the icon to the system tray...
With nfIconData
 .hWnd = Me.hWnd
 .uID = Me.Icon
 .uFlags = NIF_ICON Or NIF_MESSAGE Or NIF_TIP
 .uCallbackMessage = WM_MOUSEMOVE
 .hIcon = Me.Icon.Handle
 .szTip = "VB-Amp Pro" & Chr(0)
 .cbSize = Len(nfIconData)
End With
Call Shell_NotifyIcon(NIM_ADD, nfIconData)
End Sub

'Respond to mouse events
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

Dim lMsg As Long

lMsg = X / Screen.TwipsPerPixelX

Select Case lMsg
    Case 515 'LeftMouseDown
        If Pref.Visible = False Then
            frmVBAmp.Visible = True
            Call AlwaysOnTop(frmVBAmp, True) 'force window to top
            Call AlwaysOnTop(frmVBAmp, OptAlwaysOnTop)
        End If
    Case 516 'RightMouseDown
        PopupMenu mnuPopup, 0
End Select

End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call Shell_NotifyIcon(NIM_DELETE, nfIconData)
End Sub

'Respond to menu selections - convert to button number for main form dispatcher
Private Sub mnu_Click(Index As Integer)
    Dim n As Integer
    Select Case Index
        Case 1: n = 5
        Case 2: n = 12
        Case 3: n = 10
        Case 4: n = 11
        Case 5: n = 15
        Case 6: n = 14
        Case 7: n = 23
        Case 8: n = 6
        Case 9: n = 35
        Case 10: n = 21
        Case 11: n = 20
        Case 12: n = 1
    End Select
    Call frmVBAmp.DoIt(n)
End Sub
